Name:           compat-wxGTK26
Version:        2.6.4
Release:        3
Summary:        GTK2 port of the wxWidgets GUI library
# The wxWindows licence is the LGPL with a specific exemption allowing
# distribution of derived binaries under any terms. (This will eventually
# change to be "wxWidgets License" once that is approved by OSI.)
License:        wxWidgets
Group:          System Environment/Libraries
URL:            http://www.wxwidgets.org/
Source0:        http://dl.sf.net/wxwindows/wxGTK-%{version}.tar.bz2
Patch1:         wxGTK-2.6.3-locale-compat.patch
Patch2:         wxGTK-2.6.3-gtk-crash.patch
Patch3:         wxGTK-2.6.3-g_thread_init.patch
#Patch4:         wxGTK-2.6.3-tooltips.patch
Patch5:         wxGTK-2.6.3-expat2.patch
Patch6:         wxGTK-2.6.3-strconv.patch
Patch7:         wxGTK-2.6.4-config-script.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  gtk2-devel, zlib-devel >= 1.1.4
BuildRequires:  libpng-devel, libjpeg-devel, libtiff-devel
BuildRequires:  expat-devel, SDL-devel, libgnomeprintui22-devel
BuildRequires:  libGL-devel, libGLU-devel

Obsoletes: wxGTK < 2.8
Obsoletes: wxGTK-gl < 2.8


%description
wxWidgets/GTK2 is the GTK2 port of the C++ cross-platform wxWidgets
GUI library, offering classes for all common GUI controls as well as a
comprehensive set of helper classes for most common application tasks,
ranging from networking to HTML display and image manipulation.


%package        devel
Group:          Development/Libraries
Summary:        Development files for the wxGTK2 library
Requires:       %{name} = %{version}-%{release}
Requires:       gtk2-devel
Requires:       libGL-devel, libGLU-devel
Obsoletes:      wxGTK-devel < 2.8

%description devel
This package include files needed to link with the wxGTK2 library.


%prep
%setup -q -n wxGTK-%{version}

%patch1 -p1 -b .locale-compat
%patch2 -p1 -b .gtk-crash
%patch3 -p1 -b .g_thread_init
#patch4 -p1 -b .tooltips
%patch5 -p1 -b .expat2
%patch6 -p1 -b .strconv
%patch7 -p1 -b .config-script

sed -i -e 's|/usr/lib\b|%{_libdir}|' configure

# Avoid executable source files in debuginfo package.
find . -perm /+x -a \( -name \*.cpp -o -name \*.h \) | xargs chmod -x


%build
export GDK_USE_XFT=1

# --disable-optimise prevents our $RPM_OPT_FLAGS being overridden
# (see OPTIMISE in configure).
%configure \
  --x-libraries=%{_libdir} \
  --with-gtk=2 \
  --with-opengl \
  --without-odbc \
  --with-sdl \
  --with-gnomeprint \
  --enable-shared \
  --enable-soname \
  --disable-optimise \
  --enable-debug_info \
  --enable-unicode \
  --enable-compat22

# Work around sdl-config returning: -L%_libdir
sed -i -e 's!\(^s,@.*\)-L%{_libdir} \(.*-lSDL.*\)!\1 \2!' config.status ; ./config.status

make %{?_smp_mflags}
make %{?_smp_mflags} -C contrib/src/stc
make %{?_smp_mflags} -C contrib/src/ogl
make %{?_smp_mflags} -C contrib/src/gizmos
make %{?_smp_mflags} -C contrib/src/animate

%install
rm -rf $RPM_BUILD_ROOT

make DESTDIR=$RPM_BUILD_ROOT install
make DESTDIR=$RPM_BUILD_ROOT install -C contrib/src/stc
make DESTDIR=$RPM_BUILD_ROOT install -C contrib/src/ogl
make DESTDIR=$RPM_BUILD_ROOT install -C contrib/src/gizmos
make DESTDIR=$RPM_BUILD_ROOT install -C contrib/src/animate

# Don't want these.
rm -rf ${RPM_BUILD_ROOT}%{_datadir}/bakefile
find ${RPM_BUILD_ROOT}%{_datadir}/locale -name wxmsw.mo | xargs rm -f

# We have to rename the .mo files. Requires Patch1.
for i in ${RPM_BUILD_ROOT}%{_datadir}/locale/*/LC_MESSAGES/wxstd.mo; do
        NEWNAME=`echo $i | sed -e 's!wxstd.mo!compat-wxstd26.mo!'`;
        mv $i $NEWNAME;
done
%find_lang compat-wxstd26

# Move wx/{config/,include/} from %_libdir to /usr/lib.
if [ "%{_libdir}" != "%{_prefix}/lib" ] ; then
  mkdir -p ${RPM_BUILD_ROOT}%{_prefix}/lib
  mv ${RPM_BUILD_ROOT}%{_libdir}/wx ${RPM_BUILD_ROOT}%{_prefix}/lib
fi

# Deal with conflicting files.
cd ${RPM_BUILD_ROOT}%{_bindir}
rm -f wx-config wxrc
ln -s $(find .. -name gtk2-unicode-release-2.6|grep -v include) wx-2.6-config
cd -
mv ${RPM_BUILD_ROOT}%{_datadir}/aclocal/wxwin.m4 \
   ${RPM_BUILD_ROOT}%{_datadir}/aclocal/wxwin-2.6.m4


%clean
rm -rf $RPM_BUILD_ROOT


%post -p /sbin/ldconfig
%postun -p /sbin/ldconfig


%files -f compat-wxstd26.lang
%defattr(-,root,root,-)
%doc CHANGES*.txt COPYING.LIB LICENCE.txt README*.txt
%{_libdir}/libwx_baseu-*.so.*
%{_libdir}/libwx_baseu_net-*.so.*
%{_libdir}/libwx_baseu_xml-*.so.*
%{_libdir}/libwx_gtk2u_adv-*.so.*
%{_libdir}/libwx_gtk2u_animate-*.so.*
%{_libdir}/libwx_gtk2u_core-*.so.*
%{_libdir}/libwx_gtk2u_gizmos-*.so.*
%{_libdir}/libwx_gtk2u_gizmos_xrc*.so.*
%{_libdir}/libwx_gtk2u_html-*.so.*
%{_libdir}/libwx_gtk2u_media-*.so.*
%{_libdir}/libwx_gtk2u_ogl-*.so.*
%{_libdir}/libwx_gtk2u_xrc-*.so.*
%{_libdir}/libwx_gtk2u_stc-*.so.*
%{_libdir}/libwx_gtk2u_qa-*.so.*
# GL
%{_libdir}/libwx_gtk2u_gl-*.so.*


%files devel
%defattr(-,root,root,-)
%{_bindir}/wx-2.6-config
%{_bindir}/wxrc*
%{_includedir}/wx-2.6
%{_libdir}/libwx_*.so
%{_prefix}/lib/wx/
%{_datadir}/aclocal/*
#{_datadir}/bakefile/presets/


%changelog
* Tue Jul 15 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 2.6.4-3
- fix license tag

* Fri Feb 08 2008 Michael Schwendt <mschwendt@fedoraproject.org>
- rebuilt for GCC 4.3 as requested by Fedora Release Engineering

* Wed Nov 07 2007 Michael Schwendt <mschwendt@fedoraproject.org> - 2.6.4-1
- Update to 2.6.4.

* Sun Oct 21 2007 Michael Schwendt <mschwendt@fedoraproject.org> - 2.6.3-9
- Patch the wx-2.6-config script and move the common files to /usr/lib.
  This shall fix the multiarch conflict in compat-wxGTK26-devel (#340931).

* Fri Sep 14 2007 Michael Schwendt <mschwendt@fedoraproject.org> - 2.6.3-8
- Patch some dangerous pointer dereferences in src/common/strconv.cpp.

* Tue Aug 28 2007 Michael Schwendt <mschwendt@fedoraproject.org> - 2.6.3-7
- rebuilt for new expat (#195888)

* Tue Aug 21 2007 Michael Schwendt <mschwendt@fedoraproject.org>
- rebuilt

* Thu Aug  9 2007 Michael Schwendt <mschwendt@fedoraproject.org>
- Back out patch from -5 again, since gtk2-2.11.6-6.fc8 adds a
  compatibility fix for the old GtkToolTips API.

* Sun Aug  5 2007 Michael Schwendt <mschwendt@fedoraproject.org> - 2.6.3-5
- Temporarily disable GetTooltipColors(), which crashes with
  gtk2-2.11.6 because it accesses private/deprecated members (#250936).

* Sun Jul  8 2007 Michael Schwendt <mschwendt@fedoraproject.org> - 2.6.3-4
- Call g_thread_init early (#244542).

* Sun Jul  8 2007 Michael Schwendt <mschwendt@fedoraproject.org> - 2.6.3-3
- Avoid g_free related crashes in gtk.

* Tue Feb 20 2007 Michael Schwendt <mschwendt@fedoraproject.org> - 2.6.3-2
- Avoid executable source files in debuginfo package.
- Make wx-2.6-config symlink relative.

* Mon Feb 19 2007 Michael Schwendt <mschwendt@fedoraproject.org> - 2.6.3-1
- Turn into a compat-wxGTK26 package that coexists with wxGTK >= 2.8
  and wxGTK-devel >= 2.8
- Use standard make install.
- Don't include bakefile presets.
- Rename message object files, add patch to load them.
- Don't include wxmsw.mo.
- Rename wx-config to wx-2.6-config (to run this within packages,
  insert a wx-config symlink into PATH, for example).
- Rename aclocal files.
- Merge gl sub-package contents.
- Obsolete wxGTK, wxGTK-devel, wxGTK-gl (all less than 2.8).

* Mon Aug 28 2006 Matthew Miller <mattdm@mattdm.org> - 2.6.3-2.6.3.2.3
- bump release for FC6 rebuild

* Mon Jul  3 2006 Matthew Miller <mattdm@mattdm.org> - 2.6.3-2.6.3.2.2
- add libGL-devel and libGLU-devel requires to wxGTK-devel package
  (see bug #197501).

* Thu Apr 13 2006 Matthew Miller <mattdm@mattdm.org> - 2.6.3-2.6.3.2.1
- oops -- forgot to change mesa-libGL*-devel -> libGL*-devel

* Thu Apr 13 2006 Matthew Miller <mattdm@mattdm.org> - 2.6.3-2.6.3.2.0
- patch to cvs subrelease 2.6.3.2 (matches wxPython)

* Sat Mar 25 2006 Matthew Miller <mattdm@mattdm.org> - 2.6.3-1    
- 2.6.3 final
- remove the locale_install thing -- that was just an issue with using the
  release candidate.

* Tue Mar 21 2006 Matthew Miller <mattdm@mattdm.org> - 2.6.3-0.rc2
- update to 2.6.3-rc2 package
- all patches now upstream -- removing 'em.
- use complete 'wxWidgets' source tarball instead of the wxGTK-subset one,
  since that's all there is for the release candidate. I'm operating under
  the assumption that we'll have a wxGTK source tarball in the future --
  otherwise, I'm going to eventually have to change the name of this
  package again. :)
- add ODBC support via unixODBC as subpackage (see bug #176950)
- wait, no; comment out ODBC support as it doesn't build...
- add explicit make locale_install; apparently not done as part of
  the general 'make install' anymore.

* Mon Feb 13 2006 Matthew Miller <mattdm@mattdm.org> - 2.6.2-5
- rebuild in preparation for FC5

* Mon Feb 06 2006 Matthew Miller <mattdm@mattdm.org> - 2.6.2-4
- add wxGTK-2.6.2-socketclosefix.patch to fix aMule crashes. see
  bugzilla bug #178184
- add wxGTK-2.6.2-gcc41stringh.patch (pulled from CVS) to make build on 
  FC5 devel w/ gcc-4.1.
  
* Wed Nov 30 2005 Matthew Miller <mattdm@mattdm.org> - 2.6.2-3
- add wxGTK-2.6.2-intl_cpp.patch to deal with amule and probably other
  issues (see bug #154618 comment #47)
- obsolete wxGTK2 < 2.6.2-1 specifically, at Matthias Saou's suggestion

* Mon Nov 28 2005 Matthew Miller <mattdm@mattdm.org> - 2.6.2-2
- implemented some suggestions from Matthias Saou:
-   removed extraneous / from last line of ./configure 
-   removed -n from setup macro, since we're now actually using the
    standard name
-   don't use summary macro in opengl subpackage, as it's not clear which
    summary should get used
-   don't bother setting CC, CXX, etc., as configure script does that
-   move libdir/wx to devel subpackage

* Thu Nov 24 2005 Matthew Miller <mattdm@mattdm.org> - 2.6.2-1
- ready for actually putting into Extras
- update mesa buildreqs for new split-up xorg packaging
- libgnomeprint22-devel -> libgnomeprintui22-devel

* Tue Oct 04 2005 Toshio Kuratomi <toshio-tiki-lounge.com> - 2.6.2-0.1
- Update to 2.6.2.
- Include the sample wx bakefiles.
- Include new .mo files.
- From Paul Johnson:
  Change license to wxWidgets due to concerns over trademark infringement.
  Add dist tag.
- From Tom Callaway: Build and include libwx_gtk2u_animate-2.6.

* Thu Apr 28 2005 Matthew Miller <mattdm@mattdm.org> 2.6.1-0.1
- update to 2.6.1
- from Michael Schwendt in 2.4.2-11 package: build-require
  xorg-x11-Mesa-libGL and xorg-x11-Mesa-libGLU (the libGL and libGLU
  deps aren't provided in FC3, so not using that).
- from Thorsten Leemhuis in 2.4.2-12 package: sed -i -e
  's|/usr/lib\b|%%{_libdir}|' in configure also to fix x86_64
- properly include older 2.4.x changelog

* Wed Apr 27 2005 Matthew Miller <mattdm@mattdm.org> - 2.6.0-0.1
- include libwx_gtk2u_gizmos_xrc in file listing

* Wed Apr 27 2005 Matthew Miller <mattdm@mattdm.org> - 2.6.0-0.0
- update to 2.6.0 final release
- configure now wants "--with-gtk=2" instead of "--enable-gtk2".

